--[[
    Istelien L (implementation of Istelien quiz engine in LUA with the aim of using it in LOTRO)
	Copyright (C) 2023-2024 Alejandro Meirinhos from Spain.

	This file is part of Istelien L.
	
	Istelien L is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Istelien L is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Istelien L.  If not, see <https://www.gnu.org/licenses/>.
--]]

languages =
{
	[0] = 'English', -- 0 is "Invalid", so we set it to English by default
	[2] = 'English',
	[268435457] = 'EnglishGB' ,
	[268435459] = 'French',
	[268435460] = 'German', 		
	[268435463] = 'Russian'	
}

strings = 
{
	['English'] = 
	{
		-- GUI strings
		['txtGenSettings'] = 'General Settings',
		['txtChannel'] = 'Play in channel',
		['txtGameMode'] = 'Game goal',
		['txtGameMode1'] = 'Number of Questions',
		['txtGameMode2'] = 'Elapsed Time',
		['txtGameMode3'] = 'Player Points',
		['txtGameMode4'] = 'Team Points',
		['txtGameTarget'] = 'Target',
		['txtQuestion'] = 'question',
		['txtQuestions'] = 'questions',
		['txtMinute'] = 'minute',
		['txtMinutes'] = 'minutes',
		['txtPoint'] = 'point',
		['txtPoints'] = 'points',
		['txtSecond'] = 'second',
		['txtSeconds'] = 'seconds',
		['txtQuestionMode'] = 'Answer validation',
		['txtQuestionMode1'] = 'Semiautomatic',
		['txtQuestionMode2'] = 'Manual',
		['txtQuestionTime'] = 'Time per question',
		['txtQuestionHint'] = 'Hint at',
		['txtLogGame'] = 'Log game',
		['txtSelectQuiz'] = 'Select Quiz',
		['txtTeamSettings'] = 'Team Settings',
		['txtTeamsEnable'] = 'Enable Team play',
		['txtTeamsLock'] = 'Lock teams',
		['txtManageTeams'] = 'Manage Teams',
		['txtDifficulty'] = 'Difficulty Settings',
		['txtIgnoreCase'] = 'Ignore case',
		['txtIndulgentSpelling'] = 'Indulgent spelling',
		['txtApproximateAnswers'] = 'Approximate answers',
		['txtPercentAccuracy'] = '% accuracy',
		['txtScoring'] = 'Scoring Settings',
		['txtScoreMode'] = 'Question points',
		['txtScoreMode1'] = 'Fixed',
		['txtScoreMode2'] = 'Incremental',
		['txtScoreMode3'] = 'Custom',
		['txtCustomScores'] = 'Customize',
		['txtMultipleHits'] = 'Reward simultaneous answers',
		['txtMultipleHitsTypeSpeed'] = 'Speed threshold',
		['txtMultipleHitsTypeSpeedAdj'] = 'chars/sec',
		['txtMultipleHitsDivisor'] = 'Runner-up points',
		['txtMultipleHitsDivisor1'] = 'Fixed',
		['txtMultipleHitsDivisor2'] = 'Decreasing',
		['txtGameControls'] = 'Game Controls',
		['txtStartGame'] = 'Start Game',
		['txtPauseGame'] = 'Pause Game',
		['txtResumeGame'] = 'Resume Game',
		['txtResumeFromSave'] = 'Resume Game',
		['txtEndGame'] = 'End Game',
		['txtLoadGame'] = 'Load Game',
		['txtSaveGame'] = 'Save Game',
		['txtFlowInstructions'] = 'Use the following buttons to control game flow and react to player inputs and configured settings.\nIn semiautomatic mode you want to react as quick as possible for the best game experience.',
		['txtFinishQuestion'] = 'Finish Question',
		['txtProvideHint'] = 'Provide Hint',
		['txtAckCommand'] = 'Ack Command',
		['txtPointGift'] = 'Point Gift',
		['txtPlayers'] = 'Players',
		['txtTeams'] = 'Teams',
		['txtAnnounceScores'] = 'Announce Scores',
		['txtEndQuestion'] = 'End Question',
		['txtWrapQuestion'] = 'Wrap Question',
		['txtAskQuestion'] = 'Ask Question',
		['txtMasterScorer'] = 'Master Scorer',
		['txtMasterScorerInfo'] = 'Set the number of points each participant should earn for this question.\nBy default, suggested values according to game settings are shown',
		['txtCorrectAnswer'] = 'The answer was',
		['txtSetPoints'] = 'Set Points',
		['txtPointTo'] = 'point to',
		['txtPointsTo'] = 'points to',
		['txtAccept'] = 'Accept',
		['txtCancel'] = 'Cancel',
		['txtStandings'] = 'Standings',
		['txtPlayerStandings'] = 'Player Standings',
		['txtTeamStandings'] = 'Team Standings',
		['txtPublishResults'] = 'Publish',
		['txtAccept'] = 'Accept',
		['txtCancel'] = 'Cancel',
		['txtClearSelection'] = 'Clear Selection',
		['txtQuizLibrary'] = 'Quiz Library',
		['txtQuizLibraryInfo'] = 'Select the packages for your next game.\nClear selection to use the built-in package.',
		['txtPackageList'] = 'Package List',
		['txtUnnamedPackage'] = 'Unnamed Package',
		['txtBy'] = 'by',
		['txtUnnamedPackage'] = 'an unknown author',
		['txtCouldNotLoadAnyPackage'] = 'Could not load the configured quiz selection. Using the first on the list',
		['txtCouldNotLoadSomePackage'] = 'Could not load all the packages in configured quiz selection. Loaded the rest',
		['txtCustomizeScores'] = 'Ed. Scoring',
		['txtCustomizeScoresInfo'] = 'Use the controls below to assign scores depending on answer length',
		['txtMore'] = 'More',
		['txtWord'] = 'word',
		['txtWords'] = 'words',
		['txtAddLine'] = '+',
		['txtRemoveLine'] = '-',
		['txtTeamsManager'] = 'Teams Manager',
		['txtAvailableTeams'] = 'Available Teams',
		['txtTeamMembers'] = 'Team Members',
		['txtRegisteredPlayers'] = 'Registered Players',
		['txtAnnounceMembers'] = 'Announce Members',
		['txtAddMember'] = '<',
		['txtDeleteMember'] = '>',
		['txtAddTeam'] = '+',
		['txtDeleteTeam'] = '-',
		['txtAddPlayer'] = '+',
		['txtDeletePlayer'] = '-',
		['txtTeamsManagerInfo'] = 'Players need to be registered to join a team. Empty teams will be cleared at the beginning of the game. Lone players too until they use the chat again during gameplay. If teams are not locked, players can type "!jointeam <TeamName>" to request joining an existing or new team. You can acknowledge the command or use this window again',
		['txtAnnounceTeams'] = 'Announce Teams',
		['txtClose'] = 'Close',
		['txtName'] = 'Name',
		['txtAdd'] = 'Add',
		['txtSavegames'] = 'Saved Games',
		['txtSavegameList'] = 'List of Saved Games',
		['txtEmptySlot'] = 'Empty slot',
		['txtLoadDefaults'] = 'Load Defaults',
		['txtDeleteSelected'] = 'Delete Game',
		['txtDeletedSelectedOK'] = 'Deleted game at slot',
		['txtDeletedSelectedFail'] = 'Could not delete game at slot',
		['txtLoadGameOK'] = 'Loaded game from slot',
		['txtLoadGameFail'] = 'Could not load game from slot',
		['txtSave'] = 'Save',
		['txtSaveGameOK'] = 'Saved game to slot',
		['txtSaveGameFail'] = 'Could not save game to slot',
		['txtHelpText'] = [[Welcome to Istelien.

Two important points it's good you are aware of. Any other smaller options would be covered by the online or included documentation.

First: you can start playing right away with the included quiz library. However, you can add new quiz packages of any topic. To help you with that, there are two tools included in the plugin's folder under Istelien\Resources\Tools:
- ImportQuizCSV to create new packages from questions in a simple text file.
- ImportQuizLT to import quizzes you may have added to LOTRivia if you previously used that plugin before.
Please read each tool's README file for instructions on how to do it.

Second: the aspiration of this plugin was to be a fully automatic quiz engine that allows the host to play with others. However, LOTRO does not allow unattended chat input. There are two ways to try to overcome this:
1.- I've designed the semiautomatic mode for Answer validation to require the minimum management possible during the game. For the best experience, click any red button as soon as they appear in the interface. The ones covering the game flow are in the same position so you could manage without moving the mouse and just clicking twice on a quick succession, while you use the keyboard to play as any other player.
2.- I've included a third experimental tool called AutoFlow that reads the main window position and clicks those red buttons when they appear. Activate it after starting the game and deactivate it when finished. Read the README file as with the other tools.

Hope you enjoy playing and hosting.]],
		-- CHAT strings
		['msgMainCommand'] = 'Istelien command added. Type <rgb=#FF0000>/istelien show</rgb> or right click on the icon to open the main menu.',
		['msgHelpCommand'] = 'Click on the ? icon of the main menu for basic information or refer to the online or included documentation for details.',
		['msgHelpCommandUsers'] = 'User commands available. Type <rgb=#FF0000>!help</rgb> on the game channel to get a list.',
		['msgAvailableCommands'] = 'List of available commands',
		['msgResultsInfo'] = 'Receive the game standings',
		['msgJoinTeamInfo'] = 'Join the specified team. Create it first if it does not exist yet',
		['msgLeaveTeamInfo'] = 'Leave your team',
		['msgListTeamsInfo'] = 'List all existing teams',
		['msgListPlayersInfo'] = 'List all registered players',
		['msgListPlayersOfTeamInfo'] = 'List all the players of the specified team',
		['msgJoinedTeam'] = 'You have joined the team',
		['msgCouldNotJoinTeam'] = 'You must specify a team. Enter',
		['msgTeamChangesNotAllowed'] = 'Changes to teams are not allowed at the moment',
		['msgLeftTeam'] = 'You are now a loner',
		['msgAlreadyWithoutTeam'] = 'You were not part of any team',
		['msgOpenExclamation'] = '',
		['msgCloseExclamation'] = '!',
		['msgPointGift'] = 'Corruption',
		['msgGameMasterAdded'] = 'The Game Master has added',
		['msgPoint'] = 'point',
		['msgPoints'] = 'points',
		['msgTo'] = 'to',
		['msgFor'] = 'for',
		['msgListPlayers'] = 'List of active players',
		['msgNoPlayersRegistered'] = 'There are no registered players at the moment',
		['msgListPlayersInTeam'] = 'List of players in the team',
		['msgNoPlayersInTeamRegistered'] = 'has no members at the moment',
		['msgNoTeams'] = 'There are no teams at the moment',
		['msgListTeams'] = 'List of registered teams',
		['msgNoTeamsCreated'] = 'There are no teams at the moment',
		['msgTeamsCommandsInstructions'] = 'If teams are not locked you can use <rgb=#FFA500>!jointeam <TeamName></rgb> to join an existing or new team of your choice',
		['msgTeamsCommandsInstructions2'] = '<rgb=#FFA500>!listplayers <TeamName></rgb> lets you see the members of an existing team',
		['msgStartingGame'] = 'STARTING GAME',
		['msgStartingGameSaved'] = 'RESUMING SAVED GAME',
		['msgGameMode1'] = 'Game duration',
		['msgGameMode2'] = 'Game duration',
		['msgGameMode3'] = 'Game goal',
		['msgGameMode4'] = 'Game goal',
		['msgGameTargetType1'] = 'question',
		['msgGameTargetType1Plural'] = 'questions',
		['msgGameTargetType2'] = 'minute',
		['msgGameTargetType2Plural'] = 'minutes',
		['msgGameTargetType3'] = 'player point',
		['msgGameTargetType3Plural'] = 'player points',
		['msgGameTargetType4'] = 'team point',
		['msgGameTargetType4Plural'] = 'team points',
		['msgScoreMode1'] = 'Fixed scoring',
		['msgScoreMode2'] = 'Incremental scoring',
		['msgScoreMode3'] = 'Custom scoring',
		['msgType'] = 'Type',
		['msgForCommands'] = 'for your available commands',
		['msgPausingGame'] = 'PAUSING GAME',
		['msgAwaitingResume'] = 'There will be no new questions until it is resumed',
		['msgResumingGame'] = 'RESUMING GAME',
		['msgContinuePlaying'] = 'You can continue playing where you left it',
		['msgEndGame'] = 'END GAME',
		['msgFinalResults'] = 'Final Results',
		['msgProvisionalResults'] = 'Provisional Results',
		['msgPlayerStandings'] = 'Player standings',
		['msgTeamStandings'] = 'Team standings',
		['msgNobodyScored'] = 'Nobody scored',
		['msgNobodyScoredThisQuestion'] = 'Nobody scored on this question',
		['msgGotRightAnswer'] = 'got it',
		['msgNobodyKnew'] = 'Nobody knew',
		['msgAnswerWas'] = 'The answer was',
		['msgPlayerScore'] = 'Player score',
		['msgTeamScore'] = 'Team score',
		['msgHint'] = 'A Hint',
		['msgQuiz'] = 'Quiz',
		['msgBy'] = 'by',
		['msgQuestion'] = 'Question',
		['msgCategory'] = 'Category',	
		['msgAuthor'] = 'Author',	
		['msgTimesUp'] = 'Time\'s up',
		['msgManualWrap'] = 'The Game Master decided you had enough of this question',
	},
}


-- Defines the language for all string translations. If it's not found it will revert to English
function setLanguage()
	local languageName = languages[Turbine.Engine.GetLanguage()]
	if (strings[languageName] == nil) then
		clientLanguage = 'English'
	end
	return languageName
end

-- Translates a coded string to its proper readable text. It leaves the code if the translation is not found.
function translate(stringCode)
	if (strings[clientLanguage][stringCode] ~= nil) then
		return strings[clientLanguage][stringCode]
	else
		return stringCode
	end
end

clientLanguage = setLanguage()

-- The following sets of replacements are needed in different parts of LOTRO to show non-English characters properly. Both sets are clearly related so it all comes from some mistreating of these characters inside LOTRO.

-- This is for turning strange characters resulting from someone chatting into the good ones inside the plugin
nonbasicCharactersInChat =
{
	['À'] = '',
	['Á'] = '',
	['Â'] = '',
	['Ã'] = '',
	['Ä'] = '',
	['Å'] = '',
	['Æ'] = '',
	['Ç'] = '',
	['È'] = '',
	['É'] = '',
	['Ê'] = '',
	['Ë'] = '',
	['Ì'] = '',
	['Í'] = '',
	['Î'] = '',
	['Ï'] = '',
	['Ð'] = '',
	['Ñ'] = '',
	['Ò'] = '',
	['Ó'] = '',
	['Ô'] = '',
	['Õ'] = '',
	['Ö'] = '',
	['×'] = '',
	['Ø'] = '',
	['Ù'] = '',
	['Ú'] = '',
	['Û'] = '',
	['Ü'] = '',
	['Ý'] = '',
	['Þ'] = '',
	['ß'] = '',
	['à'] = '',
	['á'] = '',
	['â'] = '',
	['ã'] = '',
	['ä'] = '',
	['å'] = '',
	['æ'] = '',
	['ç'] = '',
	['è'] = '',
	['é'] = '',
	['ê'] = '',
	['ë'] = '',
	['ì'] = '',
	['í'] = '',
	['î'] = '',
	['ï'] = '',
	['ð'] = '',
	['ñ'] = '',
	['ò'] = '',
	['ó'] = '',
	['ô'] = '',
	['õ'] = '',
	['ö'] = '',
	['÷'] = '',
	['ø'] = '',
	['ù'] = '',
	['ú'] = '',
	['û'] = '',
	['ü'] = '',
	['ý'] = '',
	['þ'] = '',
	['ÿ'] = ''
}

-- This is for turning good non-English character into the strange composite strings that LOTRO's GUI can show as normal good characters.
nonbasicCharactersForGui =
{
	[''] = 'À',
	[''] = 'Á',
	[''] = 'Â',
	--[''] = 'Ã', -- This one, which place in the order is here, can't be done because LUA tables haven't really have an order, and if this one is not done first, it will screw previous replacements that have  as part of its result.
	[''] = 'Ä',
	[''] = 'Å',
	[''] = 'Æ',
	[''] = 'Ç',
	[''] = 'È',
	[''] = 'É',
	[''] = 'Ê',
	[''] = 'Ë',
	[''] = 'Ì',
	[''] = 'Í',
	[''] = 'Î',
	[''] = 'Ï',
	[''] = 'Ð',
	[''] = 'Ñ',
	[''] = 'Ò',
	[''] = 'Ó',
	[''] = 'Ô',
	[''] = 'Õ',
	[''] = 'Ö',
	[''] = '×',
	[''] = 'Ø',
	[''] = 'Ù',
	[''] = 'Ú',
	[''] = 'Û',
	[''] = 'Ü',
	[''] = 'Ý',
	[''] = 'Þ',
	[''] = 'ß',
	[''] = 'à',
	[''] = 'á',
	[''] = 'â',
	[''] = 'ã',
	[''] = 'ä',
	[''] = 'å',
	[''] = 'æ',
	[''] = 'ç',
	[''] = 'è',
	[''] = 'é',
	[''] = 'ê',
	[''] = 'ë',
	[''] = 'ì',
	[''] = 'í',
	[''] = 'î',
	[''] = 'ï',
	[''] = 'ð',
	[''] = 'ñ',
	[''] = 'ò',
	[''] = 'ó',
	[''] = 'ô',
	[''] = 'õ',
	[''] = 'ö',
	[''] = '÷',
	[''] = 'ø',
	[''] = 'ù',
	[''] = 'ú',
	[''] = 'û',
	[''] = 'ü',
	[''] = 'ý',
	[''] = 'þ',
	[''] = 'ÿ'
}
-- This replacement should be done right before nonbasicCharactersForGui for replacements to be complete, and never after or in the middle to be correct.
nonbasicCharactersForGuiPrev =
{
	[''] = 'Ã'
}